<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import VueSlickCarousel from 'vue-slick-carousel';
import { IsMobileMixin } from '../../mixins';
import {
  Faq as FAQ,
  Modal as SlpModal,
  LaunchDarkly,
  NextStep,
} from '~/components/common/index.vue';
import {
  NextSteps,
  Addons,
  FeatureComparison,
  FeatureList,
} from '~/components/pricing/index.vue';
import { getPageMetadata } from '~/common/meta';

const parseToKebabCase = (string: string) => {
  return string
    .toLowerCase()
    .replaceAll('?', '')
    .replace(/[&/\\#,+()$~%.'":*?<>{}\s]/g, '-');
};

export default Vue.extend({
  components: {
    FAQ,
    NextSteps,
    VueSlickCarousel,
    SlpModal,
    FeatureList,
    Addons,
    NextStep,
    FeatureComparison,
    LaunchDarkly,
  },
  nuxtI18n: false,
  mixins: [IsMobileMixin],
  async asyncData({ $content }) {
    const data = await $content('pricing/index').fetch();
    return { data };
  },
  data() {
    return {
      activeCarouselIndex: 1,
      isModalOpen: false,
      modalPlan: {},
      audience: null,
      sections: [],
      activeHeader: '',
    };
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).data, this.$route.path);
  },
  mounted() {
    this.removeNavForPathFactory();
    this.sections = this.data?.faq?.groups?.map(({ header }) => {
      const obj = { header };
      obj.id = parseToKebabCase(header);
      obj.dataGaName = parseToKebabCase(header);
      obj.dataGaLocation = 'pricing-faq';
      return obj;
    });

    window.addEventListener('load', () => {
      const queryParams = this.$route.query;
      if (
        Object.prototype.hasOwnProperty.call(
          queryParams,
          'override-enterprise',
        ) ||
        Object.prototype.hasOwnProperty.call(queryParams, 'override-smb')
      ) {
        if (
          queryParams['override-enterprise'] ||
          queryParams['override-enterprise'] === null
        ) {
          this.audience = 'gold-ultimate';
        } else if (
          queryParams['override-smb'] ||
          queryParams['override-smb'] === null
        ) {
          this.audience = 'silver-premium';
        }
      } else {
        this.getUserAudience();
      }
    });
  },
  methods: {
    focusedId(id) {
      const section = this.sections.find((s) => s.id === id);
      this.activeHeader = section.header;
    },
    carouselGoTo(index: number): void {
      const carouselRef = this.$refs.carousel as any;
      this.activeCarouselIndex = index;
      if (carouselRef.goTo) {
        carouselRef.goTo(index);
      }
    },
    handleCarouselChange(index: number): void {
      this.activeCarouselIndex = index;
    },
    openModal(plan: Object) {
      this.isModalOpen = true;
      this.modalPlan = plan;
    },
    closeModal() {
      this.isModalOpen = false;
    },
    removeNavForPathFactory() {
      const windowURL = window.location.search;
      if (windowURL.includes('menu=hide') && window.self !== window.top) {
        document.querySelector<HTMLElement>('footer.footer')!.style.display =
          'none';
        document.querySelector<HTMLElement>('.navigation')!.style.display =
          'none';
      }
    },
    getUserAudience() {
      const rawAudience =
        window?.Demandbase?.IpApi?.CompanyProfile?.audience.toLowerCase();

      if (rawAudience) {
        if (
          rawAudience.includes('enterprise') ||
          rawAudience.includes('mid-market')
        ) {
          this.audience = 'gold-ultimate';
        } else if (rawAudience.includes('smb')) {
          this.audience = 'silver-premium';
        }
      }
    },
  },
});
</script>

<template>
  <div class="pricing-container">
    <SlpContainer class="carousel-container">
      <div class="header-container">
        <SlpTypography
          tag="h1"
          variant="heading1-bold"
          data-aos="fade-right"
          data-aos-duration="800"
          class="slp-mb-16"
        >
          {{ data.heading }}
        </SlpTypography>
      </div>
      <div v-if="isMobile" class="carousel-controls">
        <button
          class="free"
          :class="{ active: activeCarouselIndex === 0 }"
          @click="carouselGoTo(0)"
        >
          <SlpTypography variant="body1-bold"> Free </SlpTypography>
        </button>
        <button
          class="premium"
          :class="{ active: activeCarouselIndex === 1 }"
          @click="carouselGoTo(1)"
        >
          <SlpTypography variant="body1-bold"> Premium </SlpTypography>
        </button>
        <button
          class="ultimate"
          :class="{ active: activeCarouselIndex === 2 }"
          @click="carouselGoTo(2)"
        >
          <SlpTypography variant="body1-bold"> Ultimate </SlpTypography>
        </button>
      </div>
      <section class="tiers-section">
        <component
          :is="isMobile ? 'VueSlickCarousel' : 'slp-row'"
          ref="carousel"
          center-mode
          :center-padding="`${width / 30}%`"
          :infinite="false"
          :dots="true"
          class="tiers"
          :initial-slide="1"
          @afterChange="handleCarouselChange"
        >
          <SlpColumn
            v-for="plan in data.plans"
            :key="plan.heading"
            class="column"
            :class="`${plan.id}-container`"
          >
            <div
              :class="[
                'tier',
                `plan-${plan.id}`,
                { active: plan.id === audience },
              ]"
            >
              <SlpTypography
                v-if="plan.id === audience"
                variant="body2"
                class="tier-pill"
                >{{ plan.pill }}</SlpTypography
              >
              <div class="content">
                <SlpTypography
                  v-if="!isMobile"
                  tag="h2"
                  variant="heading3-bold"
                  class="title"
                  >{{ plan.title }}</SlpTypography
                >
                <SlpTypography tag="p" variant="body1-bold" class="description">
                  {{ plan.description }}</SlpTypography
                >
                <div class="price-detail-container">
                  <div class="price-wrapper">
                    <div
                      v-if="plan.future_monthly_price"
                      class="price-container"
                    >
                      <span class="dollar-sign future-dollar-sign"> $ </span>
                      <SlpTypography
                        variant="heading3-bold"
                        class="future-price"
                        >{{ plan.future_monthly_price }}</SlpTypography
                      >
                    </div>
                    <div class="price-container">
                      <span class="dollar-sign"> $ </span>
                      <SlpTypography variant="heading1-bold" class="price">{{
                        plan.monthly_price
                      }}</SlpTypography>
                      <span v-if="plan.additional_text">*</span>
                    </div>
                  </div>
                  <div class="price-detail-container__detail">
                    <SlpTypography tag="p" variant="body3" class="price-monthly"
                      >per user/month</SlpTypography
                    >
                    <SlpTypography
                      v-if="plan.monthly_price === 0"
                      tag="p"
                      variant="body3"
                      class="price-annually"
                    >
                      No credit card required
                    </SlpTypography>
                    <SlpTypography
                      v-else
                      tag="p"
                      variant="body3"
                      class="price-annually"
                    >
                      Billed annually at ${{ plan.annual_price }} USD
                    </SlpTypography>
                  </div>
                </div>

                <div v-if="plan.title === 'Free'">
                  <div class="saas-button">
                    <SlpButton
                      variant="tertiary"
                      data-ga-name="free trial"
                      data-ga-location="free tier card"
                      href="https://gitlab.com/-/trial_registrations/new"
                    >
                      Free SaaS trial
                      <SlpIcon
                        v-if="plan.title === 'Free'"
                        class="slp-ml-16"
                        name="chevron-lg-right"
                        variant="product"
                        slp-color="primary-200"
                        alt="Chevron Right Icon"
                      />
                    </SlpButton>
                  </div>
                  <div class="install-button">
                    <SlpButton
                      :class="`buy-button-${plan.id}`"
                      variant="tertiary"
                      href="https://about.gitlab.com/install/"
                      data-ga-name="self managed install"
                      data-ga-location="free tier card"
                    >
                      Self-managed install
                      <SlpIcon
                        v-if="plan.title === 'Free'"
                        class="slp-ml-16"
                        name="chevron-lg-right"
                        variant="product"
                        slp-color="primary-200"
                        alt="Chevron Right Icon"
                      />
                    </SlpButton>
                  </div>
                </div>
                <div v-else>
                  <div
                    :data-ga-name="plan.data_ga_name"
                    :data-ga-location="plan.data_ga_location"
                    @click="openModal(plan)"
                  >
                    <SlpButton
                      :class="`buy-button-${plan.id}`"
                      :variant="plan.title === 'Free' ? 'tertiary' : 'primary'"
                    >
                      {{ plan.button_copy }}
                      <SlpIcon
                        v-if="plan.title === 'Free'"
                        class="slp-ml-16"
                        name="chevron-lg-right"
                        variant="product"
                        slp-color="primary-200"
                        alt="Chevron Right Icon"
                      />
                    </SlpButton>
                  </div>
                </div>

                <SlpButton
                  v-if="plan.additonal_button"
                  variant="tertiary"
                  class="slp-mt-8"
                  :href="plan.additonal_button.url"
                  :data-ga-name="plan.additonal_button.data_ga_name"
                  :data-ga-location="plan.additonal_button.data_ga_location"
                >
                  {{ plan.additonal_button.text }}
                  <SlpIcon
                    class="slp-ml-16"
                    name="chevron-lg-right"
                    variant="product"
                    slp-color="primary-200"
                    alt="Chevron Right Icon"
                  />
                </SlpButton>
                <SlpTypography
                  v-else-if="plan.additional_text"
                  tag="p"
                  variant="body3"
                  class="additional-text"
                >
                  {{ plan.additional_text.text }}
                  <a
                    v-if="plan.additional_text.url"
                    :href="plan.additional_text.url.url"
                    :data-ga-name="plan.additional_text.url.data_ga_name"
                    :data-ga-location="
                      plan.additional_text.url.data_ga_location
                    "
                  >
                    {{ plan.additional_text.url.text }}
                  </a>
                </SlpTypography>
              </div>
            </div>
            <FeatureList
              :data="plan.features"
              :tooltip-position="isMobile ? 'bottom' : 'right'"
            />
          </SlpColumn>
        </component>
      </section>

      <p class="subtitle">{{ data.subtitle }}</p>
    </SlpContainer>
    <SlpContainer>
      <FeatureComparison
        :plans="data.plans"
        :data="data.feature_comparison"
        @planSelect="(event) => openModal(event)"
      />
    </SlpContainer>
    <SlpContainer>
      <Addons :data="data.addons" />
    </SlpContainer>

    <section>
      <NextSteps :data="data.next_steps" />
    </section>
    <section>
      <SlpSectionsNavigator :sections="sections" @focusedId="focusedId" />
      <SlpContainer variant="light-purple-100">
        <FAQ
          :data="data.faq"
          :active-header="activeHeader"
          data-aos="fade-right"
          data-aos-duration="800"
          has-jump-down="true"
        />
      </SlpContainer>
    </section>
    <SlpContainer variant="gradient">
      <NextStep />
    </SlpContainer>
    <slp-modal v-if="isModalOpen" @close="closeModal">
      <div class="buy-modal">
        <div class="modal-header">
          <SlpTypography tag="h3" variant="heading3-bold"
            >Select your preferred hosting setup</SlpTypography
          >
        </div>
        <div class="types-container">
          <div class="plan-type saas">
            <SlpTypography tag="h3" variant="heading4">
              GitLab SaaS</SlpTypography
            >
            <SlpTypography tag="p" variant="body2"> (We Host)</SlpTypography>
            <SlpTypography tag="p" variant="body1" class="experience-notice">
              No technical setup required.</SlpTypography
            >
            <SlpTypography tag="p" variant="body2" class="description">
              If you don't want to worry about downloading and installing GitLab
              yourself.
            </SlpTypography>
            <div class="purchase-button">
              <SlpButton
                :class="modalPlan.title === 'Free' ? 'saas-button' : ''"
                variant="primary"
                :href="modalPlan.links.hosted.url"
                :data-ga-location="`${modalPlan.id}-modal`"
                :data-ga-name="modalPlan.links.hosted.cta_text"
                >{{ modalPlan.links.hosted.cta_text }}</SlpButton
              >
            </div>
          </div>
          <div class="plan-type self-managed">
            <SlpTypography tag="h3" variant="heading4">
              GitLab Self-Managed</SlpTypography
            >
            <SlpTypography tag="p" variant="body2"> (You Host)</SlpTypography>
            <SlpTypography tag="p" variant="body1" class="experience-notice">
              Requires Linux Experience.</SlpTypography
            >
            <SlpTypography tag="p" variant="body2" class="description">
              Download and install GitLab on your own infrastructure or in our
              public cloud environment.
            </SlpTypography>
            <div class="purchase-button">
              <SlpButton
                :class="modalPlan.title === 'Free' ? 'install-button' : ''"
                :data-ga-name="modalPlan.links.self_managed.cta_text"
                :data-ga-location="`${modalPlan.id}-modal`"
                :href="modalPlan.links.self_managed.url"
                >{{ modalPlan.links.self_managed.cta_text }}</SlpButton
              >
            </div>
          </div>
        </div>
      </div>
    </slp-modal>
  </div>
</template>

<style lang="scss">
// Allowing overflow in carousel component to prevent tooltips from being cut
.slick-list {
  overflow: visible !important;
}
</style>

<style lang="scss" scoped>
.pricing-container {
  // Added for the AOS animations, the components are initially displaced with an opacity of 0, which causes them to move outside the container
  // creating a horizontal scrollbar in mobile
  .carousel-container {
    @media (max-width: $breakpoint-lg) {
      overflow: hidden;
    }
    .header-container {
      max-width: 700px;
      margin-top: $spacing-64;
      @media (max-width: $breakpoint-md) {
        max-width: inherit;
        margin: $spacing-32 $spacing-16 0;
      }
    }
  }
}

.tiers-section {
  &:deep .slick-dots {
    bottom: -23px;
  }
}

.buy-modal {
  padding: $spacing-32 40px;
  display: flex;
  flex-direction: column;
  .modal-header {
    margin-bottom: $spacing-24;
    text-align: center;
  }
  .types-container {
    display: flex;
    @media (max-width: $breakpoint-lg) {
      flex-direction: column;
      align-items: center;
    }

    .plan-type {
      display: flex;
      flex-direction: column;
      align-items: center;
      padding: $spacing-24 0;
      min-width: 275px;
      max-width: 300px;
      text-align: center;
      &.saas {
        padding-right: 1rem;
        border-right: 1px solid #d7d7d7;
        @media (max-width: $breakpoint-lg) {
          border-bottom: 1px solid #d7d7d7;
          border-top: 1px solid #d7d7d7;
          border-right: none;
          padding-bottom: 24px;
          margin-bottom: 24px;
          padding-right: 0;
        }
      }

      &.self-managed {
        padding-left: 1rem;
        @media (max-width: $breakpoint-lg) {
          padding-left: 0;
        }
      }
      .experience-notice {
        font-weight: 600;
        margin-top: 1rem;
      }
      .description {
        margin-bottom: 1rem;
      }
      .purchase-button {
        width: 100%;
        margin-top: auto;
        justify-content: center;
      }
      .slp-button-secondary {
        background-color: #9b51e0;
      }
    }
  }
}

div.slp-col-md.column {
  height: 100%;
  padding: 0 $spacing-8;
  position: relative;
  width: 366px;
  max-width: 366px;

  &.free-container {
    z-index: 2;
  }
  &.silver-premium-container {
    z-index: 1;
  }
  &.gold-ultimate-container {
    z-index: 0;
  }

  @media (min-width: $breakpoint-sm) and (max-width: $breakpoint-lg) {
    width: 331px;
    max-width: 331px;
  }

  @media (max-width: $breakpoint-sm) {
    width: 286px;
    max-width: 286px;
  }
}

div.carousel-container {
  margin-bottom: $spacing-96;
  @media (max-width: $breakpoint-lg) {
    padding-right: 0;
    padding-left: 0;
  }
}

.carousel-controls {
  display: flex;
  width: 100%;
  justify-content: space-around;
  height: 42px;
  margin-top: $spacing-24;
  button {
    border: none;
    width: 100%;
    border-bottom: 1px solid transparent;
    opacity: 0.2;
    color: $color-primary-200;
    &.active {
      border-bottom: 1px solid #171321;
      opacity: 1;
    }
  }
}

.tiers {
  margin: $spacing-24 auto;
  justify-content: space-between;

  @media (max-width: $breakpoint-lg) {
    margin: $spacing-16 auto;
  }

  .tier {
    text-align: left;
    border-radius: $border-radius-4;
    border-style: solid;
    border: 1px solid transparent;
    padding: $spacing-24;
    margin: 0 auto $spacing-32;
    min-height: 322px;
    @media (min-width: $breakpoint-sm) {
      min-height: 432px;
    }
    @media (min-width: $breakpoint-lg) {
      min-height: 362px;
    }

    .tier-pill {
      background-color: $color-accent-500;
      color: $color-text-50;
      position: absolute;
      padding: $spacing-8 $spacing-16;
      border-radius: 20px;
      top: -17px;
    }

    &.plan-free {
      background-color: $color-surface-100;
      .asterisk {
        vertical-align: top;
      }
      button,
      a {
        padding-left: 0;
      }
      @media (max-width: $breakpoint-sm) {
        .description {
          margin-bottom: $spacing-32;
        }
      }
    }
    &.plan-silver-premium {
      background-color: $color-surface-900;

      &.active {
        border: 2px solid $color-accent-500;
      }
    }

    &.plan-gold-ultimate {
      border-radius: 4px 4px 100px 4px;
      background: url('/nuxt-images/backgrounds/ultimate_tier_gradient.png');
      border: 1px solid $color-surface-900;
      background-size: cover;
      background-repeat: no-repeat;
      background-position: center center;

      &.active {
        border: 2px solid $color-accent-500;
      }

      @media (max-width: $breakpoint-lg) {
        border-radius: 4px 4px 70px 4px;
      }
    }
  }

  .content {
    height: 100%;

    .description {
      margin-bottom: $spacing-8;
    }

    .additional-text {
      margin-top: 20px;
      font-style: italic;
    }

    .price-detail-container {
      display: flex;
      flex-direction: row;
      margin-bottom: $spacing-16;

      &__detail {
        display: flex;
        flex-direction: column;
        justify-content: center;
        margin-left: 8px;
      }

      .price-wrapper {
        display: flex;

        @media (max-width: $breakpoint-lg) {
          flex-direction: column;
        }
      }

      .price-container {
        display: flex;
        margin-right: $spacing-8;

        .dollar-sign {
          position: relative;
          top: 15px;

          @media (max-width: $breakpoint-lg) {
            position: initial;
          }
        }

        .future-dollar-sign {
          color: $color-text-200;
          font-size: 12px;
        }

        .future-price {
          color: $color-text-200;
          text-decoration: line-through;
          text-decoration-thickness: 4px;
          align-self: center;

          @media (max-width: $breakpoint-lg) {
            align-self: initial;
            text-decoration-thickness: 3px;
            font-size: 28px;
            line-height: 36px;
          }
        }
      }
    }
  }
}

.card {
  a {
    font-weight: $font-weight-bold;
    color: $color-text-link-100;
    font-size: $text-body-2;
  }

  h3 {
    margin-bottom: $spacing-16;
  }
}
</style>
